int mpi_sep_tag_combine(int ithread,char *tag_from, int ithread_to, 
    char *tag_to, int bs, int nb, int *send_from,int add){
return(mpi_sep_tag_combine_core(ithread,tag_from,ithread_to,tag_to,bs,
	1,nb,send_from,add,MPI_COMM_WORLD));
}

int mpi_sep_tag_combine_core(int ithread,char *tag_from, int ithread_to, 
    char *tag_to, int bs,int bs2, int nb, int *send_from,int add,
    MPI_Comm comm){
int i,valid,j,ierr;
int block;
MPI_Status stat;
double  big_num,done,blockd;
float *temp_buf;

big_num=(double)bs*(double)bs2;


if(ithread==ithread_to)
        temp_buf=(float*) malloc(sizeof(float)*max_mem_sep_mpi);

/* loop over parts (e.g. frequencies*/
for(i=0; i <  nb; i++){
        done=0;
  valid=1;for(j=0; j < mpi_ndead;j++){if(send_from[i]==mpi_dead_list[j])
   valid=0;}
        while(done< big_num){
                blockd=MIN(big_num-done,(double)max_mem_sep_mpi);
    block=(int)blockd;
    if(valid==1){
                if(send_from[i]==ithread){
                if(block*4!=sreed(tag_from,mem_buf_mpi,block*4)){
                  fprintf(stderr,"trouble reading from tag thread %d ,
		   tag=%s \n",
                  ithread,tag_to); 
                return(-1);
      }
                }
                if(send_from[i]!=ithread_to){
       if(ithread!=ithread_to && send_from[i]==ithread) {
         MPI_Send(mem_buf_mpi,block,MPI_FLOAT, 
         ithread_to,i+mpi_job_num,comm);
        }
       else if(ithread==ithread_to){
           if(mpi_verb==1) fprintf(stderr,"receiving %d from %d (%g of %g) \n",
	   i,send_from[i],done,big_num);
           MPI_Recv(mem_buf_mpi,block,MPI_FLOAT,
           send_from[i],i+mpi_job_num,comm,&stat);
        }
    }
    }
    else { /*dead node zero it */
      for(j=0; j < block; j++) mem_buf_mpi[j]=0.;
    }
                if(ithread==ithread_to){
     if(add==1){
                if(block*4!=sreed(tag_to,temp_buf,block*4)){
                    fprintf(stderr,"trouble writing to thread %d , 
		    tag=%s \n", ithread,tag_to); 
        return(-1);
                        }
      ierr=sseek(tag_to,-block*4,1);
      for(j=0; j < block; j++) mem_buf_mpi[j]+=temp_buf[j];
    }
                if(block*4!=srite(tag_to,mem_buf_mpi,block*4)){
                  fprintf(stderr,"trouble writing to thread %d , tag=%s \n",
        ithread,tag_to); 
        return(-1);
                        }
                }
    done+=block;
  mpi_job_num+=1;
        }
}
if(ithread==ithread_to) free(temp_buf);
return(0);
}


