# Parameter file to run sufdnmo.c
# consisting of one horizontal reflector

# create syntetic data
nt=350                         # number of time samples
dt=0.004                               # time sampling interval (s)
ft=0.                                   # time of first sample
nxo=201                                 # number of source-receiver offsets (traces)
dxo=0.01                               # offset sampling interval (km)
fxo=-1                                # first offset (km)
v00=2.0                                 # velocity at x0,z0 (km/s)
nxs=81                          # number of shotpoints
fxs=-.8                                # first shotpoint (km)
dxs=.02                                # shotpoint sampling interval (km)
ref="1:-8,1;8,1"
fpeak=10
verbose=1

